//Werte der Form "x35y-20" werden übergeben, die Zielkoordinaten erhalten dann xziel = 35, yziel = -20. Es können aber auch einzelne Koordianten geschickt werden, es muss lediglich x oder y davorstehen

#include <string.h>
int xAktuell= 0;       //aktueller Wert von x
int yAktuell= 0;       //aktueller Wert von y

float xZiel;         //xziel beihnaltet den Wert für x, der als nächter Punkt angesteuert wird 
float yZiel;         //yziel beihnaltet den Wert für y, der als nächter Punkt angesteuert wird 
int ventil;        //ventil beinhaltet den Wert 0(es soll nicht gedruckt werden) oder 1 (es soll gedruckt werden)

//von Sonia:
int pause = 250; // Wartezeit zwischen Richtungswechsel
int schnell = 1000;
int xPinAction = 3;
int xPinRichtung = 2;
int yPinAction = 5;
int yPinRichtung = 4;

int aktorGeschwindigkeit = 9;
int aktorRunter = 6;
int aktorHoch = 7;

void setup()
{
 Serial.begin(9600);
 //Linearaktor/ Ventil
 //pinMode(aktorHoch, OUTPUT);
 //pinMode(aktorGeschwindigkeit, OUTPUT);
 //pinMode(aktorRunter, OUTPUT);

 //Stepper
 pinMode(xPinRichtung, OUTPUT);
 pinMode(yPinRichtung, OUTPUT);
 pinMode(xPinAction, OUTPUT);
 pinMode(yPinAction, OUTPUT);
}


void geheNach()
{
  int xRichtung;
  int yRichtung;
  int xAbstand = abs(xAktuell-xZiel);     //betragsmäßige Differenz zwischen xaktuell und xziel
  int yAbstand = abs(yAktuell-yZiel);     //betragsmäßige Differenz zwischen yaktuell und yziel

  
  if (xAktuell >= xZiel)                  //wenn der Wert von xaktuell >= xziel ist,...
  {
    digitalWrite(xPinRichtung, HIGH);    //...wird xrichtung auf 0 gesetzt, d.h., dass die Platte um xabstand Schritte nach rechts verschoben werden muss
    xBewegen(xAbstand);
    delay(pause);
  }                        
  else 
  {
    digitalWrite(xPinRichtung, LOW);    //sonst wird xrichtung auf 1 gesetzt, d.h., dass die Platte um xabstand Schritte nach links verschoben werden muss
    xBewegen(xAbstand);
    delay(pause);
  }  

                        
  if (yAktuell >= yZiel)                  //wenn der Wert von yaktuell >= yziel ist,...
  {
    digitalWrite(yPinRichtung, HIGH);    //...wird yrichtung auf 0 gesetzt, d.h., dass die Platte um yabstand Schritte nach oben verschoben werden muss
    yBewegen(yAbstand);
    delay(pause);
  }                       
  else                                       
  {
    digitalWrite(yPinRichtung, LOW);  //sonst wird yrichtung auf 1 gesetzt, d.h., dass die Platte um yabstand Schritte nach unten verschoben werden muss
    yBewegen(yAbstand);
    delay(pause);
  }
  //xAbstand = 0; //damit, falls keine weiteren Werte kommen
  //yAbstand = 0;                        
}


void xBewegen(int laenge)
{
  int verzoegerung = 0;
  for (int i = 0; i <= laenge*106; i++)
  {
        digitalWrite(xPinAction, HIGH);
        delayMicroseconds(schnell+verzoegerung);
        digitalWrite(xPinAction, LOW);
        delayMicroseconds(schnell+verzoegerung);
        //if(verzoegerung>0)
        //{verzoegerung = verzoegerung - 20;}
   }
}



void yBewegen(int laenge)
{
    int verzoegerung = 0;
    for (int i = 0; i <= laenge*106; i++)
    {
        digitalWrite(yPinAction, HIGH);
        delayMicroseconds(schnell+verzoegerung);   //verzögerung testen
        digitalWrite(yPinAction, LOW);
        delayMicroseconds(schnell+verzoegerung);
        //if(verzoegerung>0)
        //{verzoegerung = verzoegerung - 20;}
    }
    
}


void ventilsteuerung()
{
  if (ventil == 1)
  {
    analogWrite(aktorGeschwindigkeit, 50);       //Geschwindigkeit
    digitalWrite(aktorHoch, LOW);
    digitalWrite(aktorRunter, HIGH);
    delay(100);
  }
  if (ventil == 2)
  {
    digitalWrite(aktorRunter, LOW);
    digitalWrite(aktorHoch, HIGH);
    delay(100);  
  } 
  if (ventil == 0)
  {    
    digitalWrite(aktorRunter, LOW);
    digitalWrite(aktorHoch, LOW);
    delay(100);
  }
}



void loop()
{
 xZiel = 0;
 yZiel = 0;
 geheNach();
 ventil = 1;
 ventilsteuerung();
 yZiel = 5;
 geheNach();
 xZiel = 5;
 yZiel = 0;
 geheNach();
 yZiel = 5;
 geheNach();
 xZiel = 0;
 geheNach();
 yZiel = 7.5;
 xZiel = 2.5;
 geheNach();
 xZiel = 5;
 yZiel = 5;
 geheNach();
 xZiel = 0;
 yZiel = 0;
 geheNach();
 xZiel = 5;
 geheNach();
 yZiel = -5;
 geheNach();
 ventil = 0;
 ventilsteuerung();
 }
